<?php

$http_origin = $_SERVER['HTTP_ORIGIN'];

$allowed_domains = array(
  'http://localhost:8080',
  'http://localhost',
);

if (in_array($http_origin, $allowed_domains))
{
    header("Access-Control-Allow-Origin: $http_origin");
    header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");
    header('Access-Control-Allow-Headers: Origin, Content-Type, X-Auth-Token , Authorization');
}


	$serverPath = $_POST['serverPath'];
	$fileName = $_POST['fileName'];
	$thumbFile1= $_POST['thumbFile1'];
	$thumbFile1_size = $_POST['thumbFile1_size'];
	$thumbFile2 = $_POST['thumbFile2'];
	$thumbFile2_size = $_POST['thumbFile2_size'];
	$stickyNoteContent= $_POST['stickyNoteContent'];


echo $serverPath . '/' . $fileName . '_base64.png';

	$base64_string = file_get_contents($serverPath . '/' . $fileName . '_base64.png');

echo 'after base64_string';

	base64_to_png($base64_string, $serverPath . '/' . $fileName . '.png');

echo 'after base64_to_png';


	createThumbnail($serverPath . '/' . $fileName . '.png', $thumbFile1_size, $thumbFile1_size, $serverPath, $thumbFile1);
	createThumbnail($serverPath . '/' . $fileName . '.png', $thumbFile2_size, $thumbFile2_size, $serverPath, $thumbFile2);



    $snote = fopen($serverPath . '/' . $fileName . '.txt', "wb");
    fwrite($snote, $stickyNoteContent);
    fclose($snote);

	unlink($serverPath . '/' . $fileName . '_base64.png');

	exit;



	function base64_to_png($base64_string, $output_file) {
		$ifp = fopen($output_file, "wb");

		$data = explode(',', $base64_string);

		fwrite($ifp, base64_decode($data[1]));
		fclose($ifp);

	//    return $output_file;
	}



	function createThumbnail($imageName,$newWidth,$newHeight,$moveToDir, $destName)
	{
		$path = $imageName;

		$mime = getimagesize($path);

		if($mime['mime']=='image/png'){ $src_img = imagecreatefrompng($path); }
		if($mime['mime']=='image/jpg'){ $src_img = imagecreatefromjpeg($path); }
		if($mime['mime']=='image/jpeg'){ $src_img = imagecreatefromjpeg($path); }
		if($mime['mime']=='image/pjpeg'){ $src_img = imagecreatefromjpeg($path); }

		$old_x = imageSX($src_img);
		$old_y = imageSY($src_img);

		//echo $old_x . '  ' . $old_y. '  ';

		if($old_x > $old_y)
		{
			$thumb_w    =   $newWidth;
			$thumb_h    =   $old_y/$old_x*$newWidth;
		}

		if($old_x < $old_y)
		{
			$thumb_w    =   $old_x/$old_y*$newHeight;
			$thumb_h    =   $newHeight;
		}

		if($old_x == $old_y)
		{
			$thumb_w    =   $newWidth;
			$thumb_h    =   $newHeight;
		}

		$dst_img        =   ImageCreateTrueColor($thumb_w,$thumb_h);
		$white = imagecolorallocate($dst_img, 255, 255, 255);
		imagefilledrectangle($dst_img, 0, 0, $thumb_w, $thumb_h, $white);


		// Make the background transparent
		// imagecolortransparent($dst_img, $white);



		imagecopyresampled($dst_img,$src_img,0,0,0,0,$thumb_w,$thumb_h,$old_x,$old_y);


		// New save location
		$new_thumb_loc = $moveToDir . $destName;

		if($mime['mime']=='image/png'){ $result = imagepng($dst_img,$new_thumb_loc,8); }
		if($mime['mime']=='image/jpg'){ $result = imagejpeg($dst_img,$new_thumb_loc,80); }
		if($mime['mime']=='image/jpeg'){ $result = imagejpeg($dst_img,$new_thumb_loc,80); }
		if($mime['mime']=='image/pjpeg'){ $result = imagejpeg($dst_img,$new_thumb_loc,80); }

		imagedestroy($dst_img);
		imagedestroy($src_img);
		return $result;
	}

?>